% REPRESENTACIN GRFICA DE SUPERFICIES
%
% Representar una superficie dada.
%
% ENTRADA: Fichero con una funcin explcitamente dado o con
%          una cuadrcula en cuyos vrtices esta definida la 
%          funcin.
%
% SALIDA:  Grfica con la representacin de los datos introducidos.

% DECLARACION DE VARIABLES
 syms('INP','NAME','OK','OPC', 'XI','YI','XF','YF','XD','YD','N', 'I', 'J', 'P', 'TOL', 'NN', 'X','ZZ', 'g');
 syms('FLAG','FLAG2','FLAG3', 'FUNC', 'OUP', 'K', 'A', 'R', 's', 'ss', 'fs','F','Mx','Mx1','Mn','Mn1','Dif');
 syms('K1', 'I1', 'Z1', 'IR1', 'IA1', 'J1', 'C1', 'L1', 'JA1', 'EP','XT','YT','ZT','T');

% INICIALIZACIN DE VARIABLES
 TRUE = 1;
 FALSE = 0;
 X=0;
 y=0;
 z=0;

% TITULO
 fprintf(1,'Representacion grafica de superficies.\n\n');
 OK = FALSE;

% TIPO DE INFORMACIN DEL FICHERO
   fprintf(1,'Indique como encuentra estructurada la informacion de la superficie a representar.\n');
   fprintf(1,'\t1. Ecuacion en (X,Y).\n');
   fprintf(1,'\t2. Matriz con coordenadas X,Y,Z.\n');
   FLAG = input(' ');

% ECUACION XY
        if FLAG == 1
            fprintf(1,'El fichero debe contener la funcion en terminos de x,y (en minuscula).\n');
            fprintf(1,'La funcion puede ser leidas desde:\n');
            fprintf(1,'\t1. Teclado.\n');
            fprintf(1,'\t2. Fichero.\n');
            FLAG2 = input(' ');
                if FLAG2 == 1
                    fprintf(1,'Introduzca la ecuacion en (x,y):\n');
                    s = input(' ','s');
                    F = inline(s,'x','y');
                else
                    fprintf(1,'Entrada de la funcion en terminos de X,Y.\n');
                    fprintf(1,'Escriba el nombre del fichero en la forma - disco:\\nombre.ext\n');
                    fprintf(1,'Por ejemplo:   A:\\DATA.DTA\n');
                    NAME = input(' ','s');
                    INP = fopen(NAME,'rt');
                    s = fscanf(INP,'%s',1);
                    F = inline(s,'x','y');
                end;
            OK = FALSE;
            
                while OK == FALSE
                    fprintf(1,'Indique el punto inicial de la cuadricula escribiendo las coordenadas X,Y en lineas separadas.\n');
                    XI = input(' ');
                    YI = input(' ');
                    fprintf(1,'Indique el punto final de la cuadricula escribiendo las coordenadas X,Y en lineas separadas.\n');
                    XF = input(' ');
                    YF = input(' ');    
                    fprintf(1,'Indique la distancia entre puntos en el eje X.\n');
                    XD = input(' ');
                    fprintf(1,'Indique la distancia entre puntos en el eje Y.\n');
                    YD = input(' ');
                    [x,y] = meshgrid(XI:XD:XF,YI:YD:YF);
                    z=F(x,y);
                    OK = TRUE;
                end;
            end;
        
% MATRIZ DE PUNTOS
    if FLAG == 2
        fprintf(1,'Entrada de la funcion en terminos de X,Y.\n');
        fprintf(1,'Escriba el nombre del fichero en la forma - disco:\\nombre.ext\n');
        fprintf(1,'Por ejemplo:   A:\\DATA.DTA\n');
        NAME = input(' ','s');
        INP = fopen(NAME,'rt');
        fprintf(1,'Escriba el numero de ecuaciones.\n');
        N = input(' ');
        IND = N/3;
        I = 1;
        J = 1;
            while J <= IND
                while I <= 3
                    x(I,J) = fscanf(INP,'%f',1);
                    y(I,J) = fscanf(INP,'%f',1);
                    z(I,J) = fscanf(INP,'%f',1);
                    I=I+1;
                 end;
            J=J+1;
            I=1;
            end;
    end;   

            
% TIPO DE REPRESENTACION
OKP = FALSE;
    while OKP == FALSE;
        fprintf(1,'Indique el tipo de representacion.\n');
        fprintf(1,'\t1. Clasica.\n');
        fprintf(1,'\t2. Clasica Solida.\n');
        fprintf(1,'\t3. Sombreada.\n');
        FLAG2 = input(' ');
        OK = FALSE;
        while OK == FALSE
            if (FLAG2 == 1) || (FLAG2 == 2) || (FLAG2 == 3)
                OK = TRUE;
            else
                fprintf(1,'Introduzca 1, 2 o 3.\n');
            end;
        end;
       
 % EJECUCION REPRESENTACION
        A=[79/255 168/255 206/255;102/255 187/255 215/255;130/255 196/255 222/255;154/255 217/255 234/255;192/255 230/255 241/255;203/255 235/255 230/255;230/255 246/255 236/255;205/255 233/255 148/255;178/255 212/255 125/255;154/255 201/255 123/255;241/255 222/255 163/255;241/255 206/255 112/255;240/255 175/255 109/255;193/255 156/255 103/255;199/255 130/255 61/255;199/255 90/255 52/255];
        colormap(A);

        % CLASICA
        if (FLAG2 == 1)
            mesh(z);
        end;

        % RELLENO
        if (FLAG2 == 2)
            surf(z);
        end;
       
        % SOMBREADO       
        if (FLAG2 == 3)
            surf(z);
            shading interp;
        end;
        V=[-6000,6000];
        caxis(V);
        xlabel = ('Eje X');
        ylabel = ('Eje Y');
        zlabel = ('Eje Z');
        title = (s);
       
 % MENU PRINCIPAL
        OPC = TRUE;
        while (OPC == TRUE)
            fprintf(1,'Seleccione la opcion que prefiera:.\n');
            fprintf(1,'\t1.Representar de nuevo la grafica.\n');
            fprintf(1,'\t2.Mover grafica en 3D.\n');
            fprintf(1,'\t3.Representar curvas de nivel.\n');
            fprintf(1,'\t4.Colocar letrero.\n');
            fprintf(1,'\t5.Salir.\n');
            FLAG3 = input(' '); 
            
            if (FLAG3 == 1)
                OKP = FALSE;
                OPC = FALSE;
            end;
            
            % MOVIMIENTO DE CURVA            
            if (FLAG3 == 2)
                rotate3d;
                fprintf(1,'Deje presionado el boton izquierdo del raton en la grfica y muevalo.\n\n\n');
            end;
            
            % CURVAS DE NIVEL 
            if (FLAG3 == 3)
                contour(z)
                caxis(V);
            end;
            
            % LETREROS 
            if (FLAG3==4)
                fprintf(1,'Indique el punto x,y en el que quiera introducir el letrero.\n');
                XT = input(' ');
                YT = input(' ');
                Mx1=max(z);
                Mx=max(Mx1);
                Mn1=min(z);
                Mn=min(Mn1);
                Dif=(Mx-Mn)/10;
                H=F(XT,YT);
                ZT=H+Dif;
                fprintf(1,'Indique el texto que debe contener el letrero.\n');
                T = input(' ','s');
                text(XT,YT,ZT,T,'FontSize',11,'VerticalAlignment','bottom','HorizontalAlignment','right','BackgroundColor',[236/256 241/256 248/256],'EdgeColor',[60/256 60/256 60/256],'LineWidth',1);
            end;
            
            if (FLAG3 == 5)
                OPC = FALSE;
                OKP = TRUE;
            end;
        end;
    end;